/*								    *\
 invstrspn.c	versin 1.0	28 de octubre de 2005

 Este fichero define las funciones invstrspn() , iwcsspn() ,
 strcspn() , iwcscspn() , invstrpbrk() , iwcspbrk() , invstrcpbrk() e
 iwcscpbrk() junto con los ficheros fun_invstrspn.h y Makefile . La
 utilizacin de estas funciones requiere el fichero invstrspn.h y la
 biblioteca libinvstrinv que se proporciona aparte. Se proporciona un
 programa de prueba test/test_invstrspn.c . La ayuda de uso de estas
 funciones la proporcionan los ficheros invstrspn.3 (para todas las
 funciones *spn) e invstrpbrk.3 (para todas las funciones *pbrk),
 ficheros que tienen unas condiciones de uso distintas.

 -----
 (c) Noel Torres, 2005
 * Se concede permiso para utilizar este cdigo, sin limitacin de
 fines, siempre que el cdigo resultante conceda, al menos, los mismos
 permisos que esta nota de Licencia.
 * Se concede permiso para enlazar el resultado binario de compilar
 este cdigo, sin limitacin de fines.
 * Se concede permiso para distribuir este cdigo o el resultado
 binario de su compilacin. Los receptores de dicha dinvstribucin
 obtienen del Autor los permisos de esta Licencia, no ligados a los
 permisos del distribuidor. Si se distribuyere el resultado binario de
 este cdigo, debe proporcionarse con l ste cdigo o bien
 proporcionar al receptor un medio sin coste (o con el mero coste de
 material de la copia) para obtenerlo.
 * Se concede permiso para modificar este cdigo, sin limitacin de
 fines.
 * Se concede permiso para distribuir copias modificadas de este
 cdigo. Tal distribucin debe realizarse bajo otro nombre o bien
 indicando claramente que se trata de una versin no oficial de este
 cdigo. El cdigo modificado debe proporcionar a sus receptores, al
 menos, los mismos derechos que ste. En cualquier caso, debe
 informarse al receptor de la autora de este cdigo.
 * Si se distribuye este cdigo a gran escala, compilado o no,
 enlazado o no, modificado o no, se ruega informar al autor.
 * Si encuentra este cdigo til, piense en realizar un regalo a
 alguien que lo necesite ms que usted. Un simple paquete de arroz
 puede significar la diferencia entre la vida y la muerte para
 alguien.
 -----

\*								    */

#include <string.h>
#include <stdlib.h> /*free()*/
#include "invstrinv/invstrinv.h"
#include "fun_invstrspn.h" /* Este fichero define las macros
			fun_char , fun_invstrspn , fun_invstrpbrk ,
			fun_invstrinv ,	fun_strlen y fun_strspn para
			valer char , invstrspn , invstrpbrk ,
			invstrinv , strlen o strspn o sus equivalentes
			para caracteres	anchos en funcin de los
			valores de INVSTRINV_CHAR e INVSTRSPN_CSPN ,
				    macros definidas exteriormente. */

/*							    *\
 INVSTRSPN_CSPN | 1                     | 2
 ===============*=======================*=====================
 INVSTRINV_CHAR | 1           4         | 1           4
 ---------------+-----------------------+---------------------
 fun_char       | char        wchar_t   | char       wchar_t
 fun_invstrspn  | invstrspn   iwcsspn   | invstrcspn iwcscspn
 fun_invstrpbrk | invstrcpbrk iwcscpbrk | invstrpbrk iwcspbrk
 fun_invstrinv  | invstrinv   iwcsinv   | invstrinv  iwcsinv
 fun_strlen     | strlen      wcslen    | strlen     wcslen
 fun_strspn     | strspn      wcsspn    | strcspn    wcscspn
\*				  			    */

#if INVSTRSPN_PBRK == 1
 size_t fun_invstrspn(fun_char* cadena, fun_char* skipset)
#endif /* INVSTRSPN_PBRK == 1 */
#if INVSTRSPN_PBRK == 2
 /*@null@*/ fun_char* fun_invstrpbrk(/*@returned@*/fun_char* cadena, \
  fun_char* skipset) /*La funcin (sea invstrpbrk() , iwcspbrk() ,
		     invstrcpbrk() o iwcscpbrk() ) puede devolver un
						       puntero nulo.*/
#endif /* INVSTRSPN_PBRK == 2 */
{
 fun_char* inversa;
 size_t tam;
 size_t numcarskipset;
# if INVSTRSPN_PBRK == 2
 fun_char* pbrk;
# endif /* INVSTRSPN_PBRK == 2 */

 tam=fun_strlen(cadena);

 if ( (inversa=fun_invstrinv(cadena)) != NULL )
 {
# if INVSTRSPN_PBRK == 1
  numcarskipset=fun_strspn(inversa,skipset); /*Nmero de caracteres de
					skipset de la cadena inversa*/
# endif /* INVSTRSPN_PBRK == 1 */
# if INVSTRSPN_PBRK == 2
  numcarskipset=fun_strspn(inversa,skipset); /*Nmero de caracteres de
					skipset de la cadena inversa*/
# endif /* INVSTRSPN_PBRK == 2 */

  free(inversa);
#  if INVSTRSPN_PBRK == 2
  /*@-ptrarith@*/
  if(numcarskipset==tam)
  {
   pbrk=NULL;
  }
  else{
   pbrk=cadena+tam-numcarskipset;
  }
  /*@+ptrarith@*/
#  endif /* INVSTRSPN_PBRK == 2 */
 }
 else /* if( inversa != NULL ) */
 {
#  if INVSTRSPN_PBRK == 1
  numcarskipset = (size_t)-1;
#  endif /* INVSTRSPN_PBRK == 1 */
#  if INVSTRSPN_PBRK == 2
  pbrk=NULL;
#  endif /* INVSTRSPN_PBRK == 2 */
 } /* endif ( inversa != NULL ) */

#if INVSTRSPN_PBRK == 1
return(numcarskipset);
#endif /* INVSTRSPN_PBRK == 1 */
#if INVSTRSPN_PBRK == 2
return(pbrk);
#endif /* INVSTRSPN_PBRK == 2 */
} /* Fin fun_invstrspn() */
