/*                                                                  *\
 test/test_invstrspn.c  versin 1.0     2 de noviembre de 2005
 
 Este fichero contiene un simple programa de prueba para las funciones
 invstrspn() , invstrcspn() , invstrpbrk() e invstrcpbrk() definidas
 junto con iwcsspn() , iwcsstrcspn() , iwcspbrk() e iwcscpbrk() en el
 fichero ../invstrspn.c y los ficheros ../invstrspn.h ,
 ../fun_invstrspn.h y ../Makefile .

 -----
 (c) Noel Torres, 2005
 * Para ver los trminos de la Licencia, vea el fichero ../invstrinv.c
 que acompaa.
 * Si se distribuyere este fichero sin el fichero ../invstrinv.c se
 deber adjuntar la Licencia all expresada.
 -----
\*                                                                  */

#include <stdlib.h> /* free() */
#include <stdio.h> /* printf() */
#include <string.h>
#include "../invstrspn.h" /* invstrspn() invstrcspn() invstrpbrk()
						      invstrcpbrk() */

int main(void)
{
 char* cadena="......hola mundo!......";
 char* pbrk;
 char* cpbrk;
	
# define LETRAS "abcdefghijklmnopqrstuvwxyz"

 printf("888888889999999999999999aaaaa\n"); /* Esta lnea cambia casi
					      cada vez que compilo! */
 printf("89ABCDEF0123456789ABCDEF01234\n");
 printf("%s\n",cadena);
 printf("cadena=%p\n",cadena);
 
 printf("-----------------------------\n");
 
 printf("strspn(): nmero de espacios al principio=%p\n",
					  (void *)strspn(cadena,"."));
 printf("strcspn():"
	" nmero de caracteres que no son letras al principio=%p\n",
				      (void *)strcspn(cadena,LETRAS));
 printf("strpbrk(): primer espacio al principio=%p\n",
					    pbrk=strpbrk(cadena,"."));
 /*
 printf("strcpbrk():"
 	" primer carcter que no es letra al principio=%p\n",
				       cpbrk=strcpbrk(cadena,LETRAS));
 */
 /* La funcin strcpbr() no existe en la biblioteca estndar, por eso
 queda comentada aqu.*/
 
 printf("-----------------------------\n");
 
 printf("invstrspn(): nmero de espacios al final=%p\n",
				       (void *)invstrspn(cadena,"."));
 printf("invstrcspn():"
	"nmero de caracteres que no son letras al final=%p\n",
				   (void *)invstrcspn(cadena,LETRAS));
 
 printf("invstrpbrk():"
	" car. sig. al primer espacio por el final=%p\n",
					 pbrk=invstrpbrk(cadena,"."));
 printf("invstrcpbrk():"
	" car. sig. al primer car. que no es letra por el final=%p\n",
				    cpbrk=invstrcpbrk(cadena,LETRAS));
 printf("invstrpbrk():"
	" car. sig. a la primera letra por el final=%p\n",
				      pbrk=invstrpbrk(cadena,LETRAS));
 printf("invstrcpbrk():"
	" car. sig. al primer car. que no es esp. por el final=%p\n",
				       cpbrk=invstrcpbrk(cadena,"."));

 printf("invstrpbrk():"
	" car. sig. a la primera (inexistente) z por el final=%p\n",
					 pbrk=invstrpbrk(cadena,"z"));
 printf("invstrcpbrk():"
	" car. sig. al primer (inexistente) carcter por el final=%p\n",
			    cpbrk=invstrcpbrk(cadena,".hola mund!"));
 return(0);
} /* Fin main() */
